package com.testcompany.testapp.gui;

import java.awt.BorderLayout;
import java.awt.ComponentOrientation;
import java.awt.FlowLayout;
import java.awt.Toolkit;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JProgressBar;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.JSplitPane;
import javax.swing.JTextField;
import javax.swing.ScrollPaneConstants;
import javax.swing.SpinnerNumberModel;
import javax.swing.SpringLayout;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.border.TitledBorder;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import com.testcompany.testapp.matrixmultiply.Matrix;
import com.testcompany.testapp.matrixmultiply.MatrixPanel;
import com.testcompany.testapp.maxsum.MaxSum;

public class AppFrame extends JFrame
{
	private JLabel maxSumTimeElapsed;
	private JLabel maxSumResult;
	private JProgressBar maxSumProgress;
	private JTextField maxSumNInts;
	private JSpinner spinner;
	private JTextField iterCount;
	private MatrixPanel matrixResult;
	private MatrixPanel matrixB;
	private MatrixPanel matrixA;
	private SpringLayout springLayout_2;
	private JLabel timeElapsedLabel;
	private JComboBox sizeCombo;
	private JButton maxSumRunAlgorithmButton;
	private JButton matMulRunAlgorithmButton;
	private SpringLayout springLayout_1;
	private SpringLayout springLayout;
	
	public AppFrame()
	{
		super();
		setSize(561, 584);
		setTitle("TRAPJ Test Application");
		getContentPane().setLayout(new BorderLayout());

		final JMenuBar menuBar = new JMenuBar();
		setJMenuBar(menuBar);

		final JMenu fileMenuItem = new JMenu();
		fileMenuItem.setMnemonic('F');
		fileMenuItem.setText("File");
		menuBar.add(fileMenuItem);

		final JMenuItem exitMenuItem = new JMenuItem();
		exitMenuItem.setMnemonic('x');
		exitMenuItem.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent arg0)
			{
				System.exit(0);
			}
		});
		exitMenuItem.setText("Exit");
		fileMenuItem.add(exitMenuItem);

		final JSplitPane splitPane = new JSplitPane();
		splitPane.setOrientation(JSplitPane.VERTICAL_SPLIT);
		splitPane.setDividerLocation(350);
		getContentPane().add(splitPane);

		final JPanel matMulPanel = new JPanel();
		springLayout = new SpringLayout();
		matMulPanel.setLayout(springLayout);
		splitPane.setLeftComponent(matMulPanel);
		matMulPanel.setBorder(new TitledBorder(null, "Matrix Multiplication", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));

		matMulRunAlgorithmButton = new JButton();
		matMulRunAlgorithmButton.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent arg0)
			{
				RunMatMul();
			}
		});
		matMulRunAlgorithmButton.setText("Run Algorithm");
		matMulPanel.add(matMulRunAlgorithmButton);

		final JPanel maxSumPanel = new JPanel();
		springLayout_1 = new SpringLayout();
		maxSumPanel.setLayout(springLayout_1);
		splitPane.setRightComponent(maxSumPanel);
		maxSumPanel.setBorder(new TitledBorder(null, "Max Sum", TitledBorder.DEFAULT_JUSTIFICATION, TitledBorder.DEFAULT_POSITION, null, null));

		final JPanel maxSumButtonPanel = new JPanel();
		final FlowLayout flowLayout = new FlowLayout();
		flowLayout.setAlignment(FlowLayout.LEFT);
		maxSumButtonPanel.setLayout(flowLayout);
		maxSumPanel.add(maxSumButtonPanel);
		springLayout_1.putConstraint(SpringLayout.SOUTH, maxSumButtonPanel, 1, SpringLayout.SOUTH, maxSumPanel);

		maxSumRunAlgorithmButton = new JButton();
		maxSumButtonPanel.add(maxSumRunAlgorithmButton);
		maxSumRunAlgorithmButton.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent e)
			{
				RunMaxSum(e);
			}
		});
		maxSumRunAlgorithmButton.setText("Run Algorithm");

		final JButton generateNumbersButton = new JButton();
		generateNumbersButton.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent e)
			{
				GenerateRandomIntList(e);
			}
		});
		maxSumButtonPanel.add(generateNumbersButton);
		generateNumbersButton.setText("Generate Numbers");

		final JPanel panel = new JPanel();
		final FlowLayout flowLayout_1 = new FlowLayout();
		flowLayout_1.setAlignment(FlowLayout.RIGHT);
		panel.setLayout(flowLayout_1);
		maxSumPanel.add(panel);
		springLayout_1.putConstraint(SpringLayout.SOUTH, panel, -3, SpringLayout.SOUTH, maxSumPanel);
		springLayout_1.putConstraint(SpringLayout.EAST, panel, -5, SpringLayout.EAST, maxSumPanel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumButtonPanel, 5, SpringLayout.WEST, maxSumPanel);

		final JLabel progressLabel = new JLabel();
		panel.add(progressLabel);
		progressLabel.setText("Progress");

		maxSumProgress = new JProgressBar();
		panel.add(maxSumProgress);

		final JLabel maxSumLabel = new JLabel();
		maxSumLabel.setText("Max Sum:");
		maxSumPanel.add(maxSumLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumLabel, 5, SpringLayout.WEST, maxSumPanel);
		springLayout_1.putConstraint(SpringLayout.NORTH, maxSumLabel, 5, SpringLayout.NORTH, maxSumPanel);

		final JLabel maxSumComputationLabel = new JLabel();
		maxSumComputationLabel.setText("Computation Time:");
		maxSumPanel.add(maxSumComputationLabel);
		springLayout_1.putConstraint(SpringLayout.NORTH, maxSumComputationLabel, 5, SpringLayout.SOUTH, maxSumLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumComputationLabel, 0, SpringLayout.WEST, maxSumLabel);

		maxSumTimeElapsed = new JLabel();
		maxSumTimeElapsed.setText("0 ms");
		maxSumPanel.add(maxSumTimeElapsed);
		springLayout_1.putConstraint(SpringLayout.NORTH, maxSumTimeElapsed, 0, SpringLayout.NORTH, maxSumComputationLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumTimeElapsed, 5, SpringLayout.EAST, maxSumComputationLabel);

		maxSumResult = new JLabel();
		maxSumResult.setText("Result");
		maxSumPanel.add(maxSumResult);
		springLayout_1.putConstraint(SpringLayout.NORTH, maxSumResult, 0, SpringLayout.NORTH, maxSumLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumResult, 5, SpringLayout.EAST, maxSumLabel);

		final JLabel numbersToGenerateLabel = new JLabel();
		numbersToGenerateLabel.setText("Numbers to Generate:");
		maxSumPanel.add(numbersToGenerateLabel);
		springLayout_1.putConstraint(SpringLayout.NORTH, numbersToGenerateLabel, 5, SpringLayout.SOUTH, maxSumComputationLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, numbersToGenerateLabel, 0, SpringLayout.WEST, maxSumComputationLabel);

		maxSumNInts = new JTextField();
		maxSumNInts.setDocument(new RegexConstrainedDocument("[1-9][0-9]{0,3}"));
		maxSumNInts.setText("1000");
		maxSumNInts.setColumns(6);
		maxSumPanel.add(maxSumNInts);
		springLayout_1.putConstraint(SpringLayout.NORTH, maxSumNInts, -3, SpringLayout.NORTH, numbersToGenerateLabel);
		springLayout_1.putConstraint(SpringLayout.WEST, maxSumNInts, 10, SpringLayout.EAST, numbersToGenerateLabel);

		sizeCombo = new JComboBox();
		sizeCombo.addItem("2 X 2");
		sizeCombo.addItem("3 X 3");
		sizeCombo.addItem("4 X 4");
		sizeCombo.addItem("5 X 5");
		sizeCombo.addItem("6 X 6");
		sizeCombo.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent e)
			{
				ChangeMatrixSize(e);
			}
		});
		matMulPanel.add(sizeCombo);

		final JLabel matrixSizeLabel = new JLabel();
		matrixSizeLabel.setText("Matrix Size:");
		matMulPanel.add(matrixSizeLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, sizeCombo, 4, SpringLayout.SOUTH, matrixSizeLabel);
		springLayout.putConstraint(SpringLayout.NORTH, sizeCombo, -4, SpringLayout.NORTH, matrixSizeLabel);
		springLayout.putConstraint(SpringLayout.WEST, sizeCombo, 5, SpringLayout.EAST, matrixSizeLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, matrixSizeLabel, -3, SpringLayout.SOUTH, matMulRunAlgorithmButton);
		springLayout.putConstraint(SpringLayout.NORTH, matrixSizeLabel, 3, SpringLayout.NORTH, matMulRunAlgorithmButton);
		springLayout.putConstraint(SpringLayout.WEST, matrixSizeLabel, 4, SpringLayout.EAST, matMulRunAlgorithmButton);

		final JLabel computationTimeLabel = new JLabel();
		computationTimeLabel.setText("Computation Time:");
		matMulPanel.add(computationTimeLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, computationTimeLabel, -5, SpringLayout.SOUTH, sizeCombo);
		springLayout.putConstraint(SpringLayout.NORTH, computationTimeLabel, 4, SpringLayout.NORTH, sizeCombo);
		springLayout.putConstraint(SpringLayout.WEST, computationTimeLabel, 5, SpringLayout.EAST, sizeCombo);

		timeElapsedLabel = new JLabel();
		timeElapsedLabel.setText("0 ms");
		matMulPanel.add(timeElapsedLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, timeElapsedLabel, 0, SpringLayout.SOUTH, computationTimeLabel);
		springLayout.putConstraint(SpringLayout.NORTH, timeElapsedLabel, 0, SpringLayout.NORTH, computationTimeLabel);
		springLayout.putConstraint(SpringLayout.WEST, timeElapsedLabel, 5, SpringLayout.EAST, computationTimeLabel);

		final JScrollPane matrixPane = new JScrollPane();
		matrixPane.setBorder(new BevelBorder(BevelBorder.LOWERED));
		matrixPane.setVerticalScrollBarPolicy(ScrollPaneConstants.VERTICAL_SCROLLBAR_ALWAYS);
		matrixPane.setHorizontalScrollBarPolicy(ScrollPaneConstants.HORIZONTAL_SCROLLBAR_ALWAYS);
		matMulPanel.add(matrixPane);
		springLayout.putConstraint(SpringLayout.SOUTH, matrixPane, -5, SpringLayout.NORTH, sizeCombo);
		springLayout.putConstraint(SpringLayout.NORTH, matrixPane, 5, SpringLayout.NORTH, matMulPanel);
		springLayout.putConstraint(SpringLayout.EAST, matrixPane, -5, SpringLayout.EAST, matMulPanel);
		springLayout.putConstraint(SpringLayout.WEST, matrixPane, 5, SpringLayout.WEST, matMulPanel);

		final JPanel matrixPanel = new JPanel();
		matrixPanel.setAutoscrolls(true);
		springLayout_2 = new SpringLayout();
		matrixPanel.setLayout(springLayout_2);
		matrixPane.setViewportView(matrixPanel);

		matrixA = new MatrixPanel();
		matrixPanel.add(matrixA);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixA, 25, SpringLayout.NORTH, matrixPanel);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixA, 5, SpringLayout.WEST, matrixPanel);

		final JLabel matrixALabel = new JLabel();
		matrixALabel.setText("Matrix A");
		matrixPanel.add(matrixALabel);
		springLayout_2.putConstraint(SpringLayout.SOUTH, matrixALabel, -5, SpringLayout.NORTH, matrixA);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixALabel, -21, SpringLayout.NORTH, matrixA);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixALabel, 28, SpringLayout.WEST, matrixA);

		final JLabel matrixBLabel = new JLabel();
		matrixBLabel.setText("Matrix B");
		matrixPanel.add(matrixBLabel);

		matrixB = new MatrixPanel();
		matrixPanel.add(matrixB);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixB, 26, SpringLayout.EAST, matrixA);
		springLayout_2.putConstraint(SpringLayout.SOUTH, matrixBLabel, -5, SpringLayout.NORTH, matrixB);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixBLabel, -21, SpringLayout.NORTH, matrixB);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixBLabel, 28, SpringLayout.WEST, matrixB);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixB, 0, SpringLayout.NORTH, matrixA);

		matrixResult = new MatrixPanel();
		matrixPanel.add(matrixResult);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixResult, 26, SpringLayout.EAST, matrixB);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixResult, 0, SpringLayout.NORTH, matrixB);

		final JLabel matrixResultLabel = new JLabel();
		matrixResultLabel.setText("Result");
		matrixPanel.add(matrixResultLabel);
		springLayout_2.putConstraint(SpringLayout.SOUTH, matrixResultLabel, -5, SpringLayout.NORTH, matrixResult);
		springLayout_2.putConstraint(SpringLayout.NORTH, matrixResultLabel, -21, SpringLayout.NORTH, matrixResult);
		springLayout_2.putConstraint(SpringLayout.WEST, matrixResultLabel, 30, SpringLayout.WEST, matrixResult);

		final JLabel crossProdLabel = new JLabel();
		crossProdLabel.setHorizontalAlignment(SwingConstants.CENTER);
		crossProdLabel.setText("X");
		matrixPanel.add(crossProdLabel);
		springLayout_2.putConstraint(SpringLayout.EAST, crossProdLabel, 0, SpringLayout.WEST, matrixB);
		springLayout_2.putConstraint(SpringLayout.WEST, crossProdLabel, 5, SpringLayout.EAST, matrixA);
		springLayout_2.putConstraint(SpringLayout.SOUTH, crossProdLabel, 0, SpringLayout.SOUTH, matrixB);
		springLayout_2.putConstraint(SpringLayout.NORTH, crossProdLabel, 0, SpringLayout.NORTH, matrixA);

		final JLabel equalsLabel = new JLabel();
		equalsLabel.setHorizontalAlignment(SwingConstants.CENTER);
		equalsLabel.setText("=");
		matrixPanel.add(equalsLabel);
		springLayout_2.putConstraint(SpringLayout.EAST, equalsLabel, -5, SpringLayout.WEST, matrixResult);
		springLayout_2.putConstraint(SpringLayout.WEST, equalsLabel, 0, SpringLayout.EAST, matrixB);
		springLayout_2.putConstraint(SpringLayout.SOUTH, equalsLabel, 0, SpringLayout.SOUTH, matrixResult);
		springLayout_2.putConstraint(SpringLayout.NORTH, equalsLabel, 0, SpringLayout.NORTH, matrixB);

		final JButton randomMatrixButton = new JButton();
		randomMatrixButton.addActionListener(new ActionListener() {
			public void actionPerformed(final ActionEvent e)
			{
				GenerateRandomMatrix(e);
			}
		});
		randomMatrixButton.setText("Random Matrix");
		matMulPanel.add(randomMatrixButton);
		springLayout.putConstraint(SpringLayout.SOUTH, randomMatrixButton, -5, SpringLayout.SOUTH, matMulPanel);
		springLayout.putConstraint(SpringLayout.NORTH, randomMatrixButton, -28, SpringLayout.SOUTH, matMulPanel);
		springLayout.putConstraint(SpringLayout.EAST, randomMatrixButton, 90, SpringLayout.WEST, matMulPanel);
		springLayout.putConstraint(SpringLayout.WEST, randomMatrixButton, 5, SpringLayout.WEST, matMulPanel);
		springLayout.putConstraint(SpringLayout.EAST, matMulRunAlgorithmButton, 0, SpringLayout.EAST, randomMatrixButton);
		springLayout.putConstraint(SpringLayout.WEST, matMulRunAlgorithmButton, 0, SpringLayout.WEST, randomMatrixButton);
		springLayout.putConstraint(SpringLayout.SOUTH, matMulRunAlgorithmButton, -5, SpringLayout.NORTH, randomMatrixButton);

		final JLabel iterationCountLabel = new JLabel();
		iterationCountLabel.setText("Iteration Count:");
		matMulPanel.add(iterationCountLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, iterationCountLabel, -5, SpringLayout.SOUTH, randomMatrixButton);
		springLayout.putConstraint(SpringLayout.NORTH, iterationCountLabel, 4, SpringLayout.NORTH, randomMatrixButton);
		springLayout.putConstraint(SpringLayout.WEST, iterationCountLabel, 4, SpringLayout.EAST, randomMatrixButton);

		iterCount = new JTextField();
		iterCount.setColumns(6);
		iterCount.setComponentOrientation(ComponentOrientation.RIGHT_TO_LEFT);
		iterCount.setDocument(new RegexConstrainedDocument("[1-9][0-9]{0,3}"));
		iterCount.setText("1");
		matMulPanel.add(iterCount);
		springLayout.putConstraint(SpringLayout.EAST, iterCount, 155, SpringLayout.WEST, iterationCountLabel);
		springLayout.putConstraint(SpringLayout.WEST, iterCount, 5, SpringLayout.EAST, iterationCountLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, iterCount, 4, SpringLayout.SOUTH, iterationCountLabel);
		springLayout.putConstraint(SpringLayout.NORTH, iterCount, -3, SpringLayout.NORTH, iterationCountLabel);
		
		sizeCombo.setSelectedIndex(0);

		final JLabel cellSizeLabel = new JLabel();
		cellSizeLabel.setText("Cell Size:");
		matMulPanel.add(cellSizeLabel);
		springLayout.putConstraint(SpringLayout.SOUTH, cellSizeLabel, -4, SpringLayout.SOUTH, iterCount);
		springLayout.putConstraint(SpringLayout.NORTH, cellSizeLabel, 3, SpringLayout.NORTH, iterCount);
		springLayout.putConstraint(SpringLayout.WEST, cellSizeLabel, 5, SpringLayout.EAST, iterCount);

		spinner = new JSpinner();
		spinner.addChangeListener(new ChangeListener() {
			public void stateChanged(final ChangeEvent arg0)
			{
				int newValue = ((Integer)spinner.getValue()).intValue();
				matrixA.setCellSize(newValue);
				matrixB.setCellSize(newValue);
				matrixResult.setCellSize(newValue);
			}
		});
		final SpinnerNumberModel spinnerNumberModel = new SpinnerNumberModel();
		spinnerNumberModel.setValue(new Integer(28));
		spinnerNumberModel.setStepSize(new Integer(1));
		spinnerNumberModel.setMaximum(new Integer(60));
		spinnerNumberModel.setMinimum(new Integer(28));
		final SpinnerNumberModel spinnerNumberModel_1 = new SpinnerNumberModel();
		spinnerNumberModel_1.setValue(new Integer(28));
		spinnerNumberModel_1.setStepSize(new Integer(1));
		spinnerNumberModel_1.setMaximum(new Integer(60));
		spinnerNumberModel_1.setMinimum(new Integer(28));
		spinnerNumberModel_1.setMaximum(null);
		spinner.setModel(spinnerNumberModel_1);
		matMulPanel.add(spinner);
		springLayout.putConstraint(SpringLayout.SOUTH, spinner, 4, SpringLayout.SOUTH, cellSizeLabel);
		springLayout.putConstraint(SpringLayout.NORTH, spinner, -3, SpringLayout.NORTH, cellSizeLabel);
		springLayout.putConstraint(SpringLayout.WEST, spinner, 5, SpringLayout.EAST, cellSizeLabel);
		
		MaxSum maxSum = MaxSum.getInstance();
		maxSum.setProgressBar(maxSumProgress);
		maxSum.setResultControls(maxSumResult, maxSumTimeElapsed);
	}
	
	// Matrix Multiplication Example
	private void RunMatMul()
	{
		int iterations = 0;
		try { iterations = Integer.parseInt(iterCount.getText()); }
		catch(Exception e) { iterations = -1; }
		if(iterations < 1)
		{
			iterations = 1;
			iterCount.setText("1");
			Toolkit.getDefaultToolkit().beep();
		}
		
		
		long startTime = System.currentTimeMillis();
		
		for(int i = 0; i < iterations; i++)
		{
			Matrix a = new Matrix(matrixA.toIntArray());
	        Matrix b = new Matrix(matrixB.toIntArray());
	        Matrix c = Matrix.multiply(a, b);
	        matrixResult.setMatrix(c.toIntArray());
		}
        
        long endTime = System.currentTimeMillis();
        long elapsed = endTime - startTime;
        timeElapsedLabel.setText(elapsed + " ms");
	}
	
	private void ChangeMatrixSize(ActionEvent e)
	{
		JComboBox cb = (JComboBox)e.getSource();
        String sizeStr = (String)cb.getSelectedItem();
        int newSize = 0;
        try { newSize = Integer.parseInt("" + sizeStr.charAt(0)); }
        catch(Exception ex) { }
        
        matrixA.setMatrixSize(newSize);
        matrixB.setMatrixSize(newSize);
        matrixResult.setMatrixSize(newSize);
	}
	
	private void GenerateRandomMatrix(ActionEvent e)
	{
		int sizeA = matrixA.getMatrixSize();
		int sizeB = matrixB.getMatrixSize();
		matrixA.setMatrix(Matrix.getRandom(sizeA, -100, 100));
		matrixB.setMatrix(Matrix.getRandom(sizeB, -100, 100));
	}
	
	// Max Sum Example
	private void RunMaxSum(ActionEvent e)
	{
		MaxSum maxSum = MaxSum.getInstance();
		maxSum.setProgressBar(maxSumProgress);
		maxSum.setResultControls(maxSumResult, maxSumTimeElapsed);
		
		maxSum.runAlgorithm();
	}
	
	private void GenerateRandomIntList(ActionEvent e)
	{
		int nInts = 0;
		try { nInts = Integer.parseInt(maxSumNInts.getText()); }
		catch(Throwable t) { return; }
		
		MaxSum.getInstance().randomize(nInts);
	}
	
	
}
