
package com.testcompany.testapp.maxsum;

import java.util.List;

public class MaxSumAlg extends Thread
{
	private int[] myIntList;
	
	public MaxSumAlg(List<Integer> intList)
	{
		myIntList = new int[intList.size()];
		for(int i = 0; i < intList.size(); i++)
			myIntList[i] = intList.get(i);
	}
	
	public void run()
	{
		MaxSum.getInstance().startTask();
		long start = System.currentTimeMillis();
		int maxSum = computeMaxSum(myIntList);
		long elapsed = System.currentTimeMillis() - start;
		MaxSum.getInstance().finishTask();
		
		MaxSum.getInstance().setResult(maxSum, elapsed);
	}
	
	private int computeMaxSum(int[] myIntList)
	{
		int maxSum = 0;
		int length = myIntList.length;

		for (int i = 0; i <= length; i++)
		{
			for (int j = i; j <= length; j++)
			{
				int sum = 0;
				
				for (int k = i; k < j; k++)
					sum += ((Integer)myIntList[k]).intValue();
				
				maxSum = Math.max(maxSum, sum);
			}
		}
		
		return maxSum;
	}
	
	public String toString()
	{
		return "MaxSumAlg (Original)";
	}
}